#####################################################################
# Code to fit Challenger data set using glm (Classical inference)   #
#####################################################################

data set
##################

rm(list=ls())
y<-c(0,1,0,0,0,0,0,0,1,1,1,0,0,1,0,0,	
0,0,0,0,1,0,1)
temp<-c(66,70,69,68,67,72,73,70,57,63,70,
78,67,53,67,75,70,81,76,79,75,76,58)	

#descriptives statistics
########################

par(mfrow=c(1,2))
plot(y,temp,ylim=c(50,90))
boxplot(y,temp,ylim=c(50,90))

summary(temp)

###############
#Fit of Models
###############

#Logito
#######

ajuste1<-glm(y~temp,family=binomial(link="logit"))
#ajuste1
summary(ajuste1)

#Test Wald
w = -0.2322/0.1082
w
pnorm(w)

#TRV
anova(ajuste1,test="Chisq")
trv = 2*(28.267 - 20.315)
trv
valorp = 1 - pchisq(trv, 1)
valorp

#Probito
########
ajuste2<-glm(y~temp,family=binomial(link="probit"))
#ajuste2
summary(ajuste2)

#Wald
w = -0.1351/0.05645
w
pnorm(w)

#TRV
anova(ajuste2,test="Chisq")
trv = 2*(28.267-20.378)
trv
valorp = 1-pchisq(trv,1)
valorp

#Cloglog
########
ajuste3<-glm(y~temp,family=binomial(link="cloglog"))
#ajuste3
summary(ajuste3)

#wald
w= -0.1958/0.07809
w
pnorm(w)

#TRV
anova(ajuste3,test="Chisq")
trv = 2*(28.267-19.531)
trv
valorp = 1-pchisq(trv,1)
valorp

#Cauchit
########
ajuste4<-glm(y~temp,family=binomial(link="cauchit"))
#ajuste4
summary(ajuste4)

#Wald
w = -0.3601/0.2779
W
pnorm(w)

#TRV
anova(ajuste4,test="Chisq")
trv = 2*(28.267-19.637)
trv
valorp = 1-pchisq(trv,1)
valorp

#grfico de curvas previstas de los modelos propuestos
#######################################################
x<-seq(30,100,0.1)
m1<-exp(15.0429-0.2322*x)/(1+exp(15.0429-0.2322*x))
m2<-pnorm(8.77490 -0.13510*x)
m3<-1-exp(-exp(12.30215 -0.19583 *x))
m4<-pcauchy( 23.1933 -0.3601*x)


par(mfrow=c(1,1))
plot(temp,y,pch=16,ylab="falhas",xlab="Temperature"
,xlim=c(30,100),ylim=c(0,1.05))
lines(x,m1, lty=2,lwd=2, col=2)
lines(x,m2, lty=3,lwd=2, col=4)
lines(x,m3, lty=6,lwd=2, col=3)
lines(x,m4, lty=1,lwd=2, col=1)
legend(32,0.8,lty=c(2,3,6,1),col=c(2,4,3,1),lwd=2,
			c("logstico","probito","clog-log","cauchy"),bty="n")

lines(c(64.78424,64.78424),c(0,0.50),lty=3)
lines(c(0,64.78424),c(0.50,0.50),lty=3)
legend(65,0.55,c("(64.78424, 0.5)"),bty="n",cex=0.8)



# QQ plot para los modelos
##########################
par(mfrow=c(2,2))
ntot<-c(rep(c(1),23))
dados <- data.frame(y,temperatura)
attach(dados)
fit.model <- m1
source("http://www.ime.usp.br/~giapaula/envelr_bino")
title(sub="Funcion de enlace logistica")
fit.model <- m2
source("http://www.ime.usp.br/~giapaula/envelr_bino")
title(sub="Funcin de enlace Probito")
fit.model <- m3
source("http://www.ime.usp.br/~giapaula/envelr_bino")
title(sub="Funcin de enlace Clog-log")
fit.model <- m4
source("http://www.ime.usp.br/~giapaula/envelr_bino")
title(sub="Funcin de enlace Cauchy")




##Estimativa para 31F
#####################
t0= 31
#probabilidade predita
#logit
plogis(15.0429-0.2322*t0
#cloglog
1 - exp(-exp(12.3021 - 0.1958*t0



